﻿Public Class Form2
    Dim SqlStr As String
    Dim SqlWhere As String

    Private Sub Form2_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try
            fuelleSCountry()
            fuelleCustomerID()

            'setting fonts after c1combo initialization
            C1DockingTab1.Font = New Font("Microsoft Sans Serif", 8.25!, FontStyle.Bold)
            GroupBox1.Font = New Font("Microsoft Sans Serif", 8.25!, CType(FontStyle.Bold Or FontStyle.Underline, FontStyle), GraphicsUnit.Point, CType(0, Byte))
            ID.Font = New Font("Microsoft Sans Serif", 8.25!, FontStyle.Bold)
            SCountry.Font = New Font("Microsoft Sans Serif", 8.25!, FontStyle.Bold, GraphicsUnit.Point, CType(0, Byte))
        Catch ex As Exception
            MsgBox("Fehler 'Form2_Load' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub fuelleSCountry()
        Try
            Dim ds As New DataSet
            Dim da As Odbc.OdbcDataAdapter
            SqlStr = "SELECT CCountry FROM Tabelle1 GROUP BY CCountry ORDER BY CCountry;"
            da = New Odbc.OdbcDataAdapter(SqlStr, "Dsn=C1Combobox.mdb;dbq=|DataDirectory|\C1Combobox.mdb;driverid=25;fil=MS Access;maxbuffersize=2048;pagetimeout=5;uid=admin")
            da.Fill(ds, "CountryList")
            With SCountry
                .ClearItems()
                .DataSource = Nothing
                .DisplayMember = "CCountry"
                .DefColWidth = 171
                .ValueMember = "CCountry"
                Dim before = Now
                .DataSource = ds.Tables("CountryList")
                Debug.WriteLine($"setting CountryList DS: {(Now - before).TotalMilliseconds}ms")
                '.Splits(0).DisplayColumns(0).Visible = False
            End With

        Catch ex As Exception
            MsgBox("Fehler 'fuelleSCountry' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub BtnLFSuchen_Click(sender As Object, e As EventArgs) Handles BtnLFSuchen.Click
        Try
            If Len(SCustomer.Text) > 0 And Len(SCountry.Text) > 0 Then
                SqlWhere = "CustomerName LIKE '%" & SCustomer.Text & "%' and CCountry = '" & SCountry.Text & "'"
            ElseIf Len(SCustomer.Text) > 0 Then
                SqlWhere = "CustomerName LIKE '%" & SCustomer.Text & "%'"
            ElseIf Len(SCountry.Text) > 0 Then
                SqlWhere = "CCountry = '" & SCountry.Text & "'"
            Else
                SqlWhere = ""
            End If
            fuelleCustomerID()

        Catch ex As Exception
            MsgBox("Fehler 'BtnLFSuchen_Click' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub fuelleCustomerID()
        Try
            Dim ds As New DataSet
            Dim da As Odbc.OdbcDataAdapter
            SqlStr = "SELECT ID, CustomerName, CustomerShortName, CStreet, CZipCode, CDistrict, CRegion, CCodeCountry, CCountry, CInfo, CStatus, CStatusInfo FROM Tabelle1 "
            If Len(SqlWhere) > 0 Then
                SqlStr &= "WHERE " & SqlWhere
            End If
            SqlStr &= " Order by CustomerShortName"
            da = New Odbc.OdbcDataAdapter(SqlStr, "Dsn=C1Combobox.mdb;dbq=|DataDirectory|\C1Combobox.mdb;driverid=25;fil=MS Access;maxbuffersize=2048;pagetimeout=5;uid=admin")
            da.Fill(ds, "CustomerList")
            With ID
                .ClearItems()
                .DataSource = Nothing
                .DisplayMember = "CustomerName"
                .DefColWidth = 440
                .ValueMember = "ID"
                Dim before = Now
                .DataSource = ds.Tables("CustomerList")
                Debug.WriteLine($"setting CustomerList DS: {(Now - before).TotalMilliseconds}ms")
                .Splits(0).DisplayColumns(0).Visible = False
                '.Splits(0).DisplayColumns(1).Visible = False    'CustomerName
                .Splits(0).DisplayColumns(2).Visible = False    'CustomerShortName
                .Splits(0).DisplayColumns(3).Visible = False    'CStreet
                .Splits(0).DisplayColumns(4).Visible = False    'CZipCode
                .Splits(0).DisplayColumns(5).Visible = False    'CDistrict
                .Splits(0).DisplayColumns(6).Visible = False    'CRegion
                .Splits(0).DisplayColumns(7).Visible = False    'CCodeCountry
                .Splits(0).DisplayColumns(8).Visible = False    'CCountry
                .Splits(0).DisplayColumns(9).Visible = False    'CInfo
                .Splits(0).DisplayColumns(10).Visible = False   'CStatus
                .Splits(0).DisplayColumns(11).Visible = False   'CStatusInfo
            End With

        Catch ex As Exception
            MsgBox("Fehler 'fuelleCustomerID' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub ID_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ID.TextChanged
        Try
            If Len(ID.Text) > 0 Then
                If ID.Columns.Item(3).Value.Length > 0 Then
                    CStreet.Text = ID.Columns.Item(3).Value
                Else
                    CStreet.Text = ""
                End If
                If ID.Columns.Item(4).Value.Length > 0 Then
                    CZipCode.Text = ID.Columns.Item(4).Value
                Else
                    CZipCode.Text = ""
                End If

                If ID.Columns.Item(5).Value.Length > 0 Then
                    CDistrict.Text = ID.Columns.Item(5).Value
                Else
                    CDistrict.Text = ""
                End If
                If ID.Columns.Item(6).Value.Length > 0 Then
                    CRegion.Text = ID.Columns.Item(6).Value
                Else
                    CRegion.Text = ""
                End If
                If ID.Columns.Item(8).Value.Length > 0 Then
                    CCountry.Text = ID.Columns.Item(8).Value
                Else
                    CCountry.Text = ""
                End If
                If ID.Columns.Item(9).Value.Length > 0 Then
                    CInfo.Text = ID.Columns.Item(9).Value
                Else
                    CInfo.Text = ""
                End If
                If ID.Columns.Item(10).Value.Length > 0 Then
                    CStatus.Text = ID.Columns.Item(10).Value
                Else
                    CStatus.Text = ""
                End If
                If ID.Columns.Item(11).Value.Length > 0 Then
                    CStatusInfo.Text = ID.Columns.Item(11).Value
                Else
                    CStatusInfo.Text = ""
                End If
            Else
                CStreet.Text = ""
                CZipCode.Text = ""
                CDistrict.Text = ""
                CRegion.Text = ""
                CCountry.Text = ""
                CInfo.Text = ""
                CStatus.Text = ""
                CStatusInfo.Text = ""
            End If

        Catch ex As Exception
            MsgBox("Error 'ID_TextChanged' :" & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub
End Class